







#ifndef MACHREGS_H
#define MACHREGS_H

#if defined(__STG_GCC_REGS__) || defined(COMPILING_NCG)

#include "StgMachDeps.h"

















































































































































#if defined(alpha_TARGET_ARCH)
# define REG(x) __asm__("$" #x)

# if defined(MARK_REG_MAP)
#  define REG_Mark  	9
#  define REG_MStack  	10
#  define REG_MRoot	11
#  define REG_BitArray    12
#  define REG_HeapBase	13
#  define REG_HeapLim 	14
# else
# if defined(SCAN_REG_MAP)
#  define REG_Scan  	9
#  define REG_New  	10
#  define REG_LinkLim	11
# else
# if defined(SCAV_REG_MAP)
#  define REG_Scav  	9
#  define REG_ToHp  	10
# if defined(GCap) || defined(GCgn)
#  define REG_OldGen	11
# endif	/* GCap || GCgn */

# else	/* default: MAIN_REG_MAP */
/* callee saves */
#  define CALLEE_SAVES_FltReg1
#  define CALLEE_SAVES_FltReg2
#  define CALLEE_SAVES_FltReg3
#  define CALLEE_SAVES_FltReg4
#  define CALLEE_SAVES_DblReg1
#  define CALLEE_SAVES_DblReg2
#  define CALLEE_SAVES_SpA
#  define CALLEE_SAVES_SuA
#  define CALLEE_SAVES_SpB
#  define CALLEE_SAVES_SuB
#  define CALLEE_SAVES_Hp
#  define CALLEE_SAVES_HpLim
  
#  define CALLEE_SAVES_Ret

/* caller saves */
#  define CALLER_SAVES_R1
#  define CALLER_SAVES_R2
#  define CALLER_SAVES_R3
#  define CALLER_SAVES_R4
#  define CALLER_SAVES_R5
#  define CALLER_SAVES_R6
#  define CALLER_SAVES_R7
#  define CALLER_SAVES_R8
  
#  define CALLER_SAVES_USER
  
#  define REG_R1	1
#  define REG_R2    	2
#  define REG_R3    	3
#  define REG_R4    	4
#  define REG_R5    	5
#  define REG_R6    	6
#  define REG_R7    	7
#  define REG_R8    	8

#  define REG_Flt1	f2
#  define REG_Flt2	f3
#  define REG_Flt3	f4
#  define REG_Flt4	f5
  
#  define REG_Dbl1	f6
#  define REG_Dbl2	f7
  
#  define REG_SpA    	9
#  define REG_SuA    	10
#  define REG_SpB    	11
#  define REG_SuB    	12
  
#  define REG_Hp	13
#  define REG_HpLim	14
  
#  define REG_Ret	15
  
#  define NCG_Reserved_I1 22
#  define NCG_Reserved_I2 27
#  define NCG_Reserved_F1 f29
#  define NCG_Reserved_F2 f30

# endif	/* !SCAV_REG_MAP */
# endif	/* !SCAN_REG_MAP */
# endif	/* !MARK_REG_MAP */

#endif /* alpha */


























#if hppa1_1_TARGET_ARCH

#define REG(x) __asm__("%" #x)

#if defined(MARK_REG_MAP)
#define REG_Mark  	r4
#define REG_MStack  	r5
#define REG_MRoot	r6
#define REG_BitArray    r7
#define REG_HeapBase	r8
#define REG_HeapLim 	r9
#else
#if defined(SCAN_REG_MAP)
#define REG_Scan  	r4
#define REG_New  	r5
#define REG_LinkLim	r6
#else
#if defined(SCAV_REG_MAP)
#define REG_Scav  	r4
#define REG_ToHp  	r5
#if defined(GCap) || defined(GCgn)
#define REG_OldGen	r6
#endif	/* GCap || GCgn */
#else	/* default: MAIN_REG_MAP */

/* callee saves */
#define CALLEE_SAVES_FltReg1
#define CALLEE_SAVES_FltReg2
#define CALLEE_SAVES_FltReg3
#define CALLEE_SAVES_FltReg4
#define CALLEE_SAVES_DblReg1
#define CALLEE_SAVES_DblReg2
/* ToDo: improve? */
#if HAVE_LONG_LONG && SIZEOF_LONG < 8
#define CALLEE_SAVES_LngReg1
#define CALLEE_SAVES_LngReg2
#endif
#define CALLEE_SAVES_SpA
#define CALLEE_SAVES_SuA
#define CALLEE_SAVES_SpB
#define CALLEE_SAVES_SuB
#define CALLEE_SAVES_Hp
#define CALLEE_SAVES_HpLim

#define CALLEE_SAVES_Ret

#define CALLEE_SAVES_R1
#define CALLEE_SAVES_R2
#define CALLEE_SAVES_R3
#define CALLEE_SAVES_R4
#define CALLEE_SAVES_R5
#define CALLEE_SAVES_R6
#define CALLEE_SAVES_R7
#define CALLEE_SAVES_R8

/* caller saves -- none */

#define REG_R1		r11
#define REG_R2    	r12
#define REG_R3    	r13
#define REG_R4    	r14
#define REG_R5    	r15
#define REG_R6    	r16
#define REG_R7    	r17
#define REG_R8    	r18

#define REG_Flt1	fr12
#define REG_Flt2	fr12R
#define REG_Flt3	fr13
#define REG_Flt4	fr13R

#define REG_Dbl1	fr20	/* L & R */
#define REG_Dbl2	fr21	/* L & R */

#define REG_SpA    	r4
#define REG_SuA    	r5
#define REG_SpB    	r6
#define REG_SuB    	r7

#define REG_Hp	    	r8
#define REG_HpLim	r9

#define REG_Ret	        r10

/* #define REG_StkStub  	r2 */

#define NCG_Reserved_I1 r28
#define NCG_Reserved_I2	r29
#define NCG_Reserved_F1	fr8
#define NCG_Reserved_F2	fr8R
#define NCG_Reserved_D1	fr10
#define NCG_Reserved_D2	fr11

#endif	/* SCAV_REG_MAP */
#endif	/* SCAN_REG_MAP */
#endif	/* MARK_REG_MAP */

#endif /* hppa */














#if i386_TARGET_ARCH

#define REG(x) __asm__("%" #x)

#if defined(MARK_REG_MAP)
#define REG_MarkBase    ebx
#define REG_Mark	ebp
#define REG_MStack	esi
#define REG_MRoot	edi

#else
#if defined(SCAN_REG_MAP)
#define REG_Scan	ebx
#define REG_New		ebp
#define REG_LinkLim	esi

#else
#if defined(SCAV_REG_MAP)
#define REG_Scav  	ebx
#define REG_ToHp	ebp
#if defined(GCap) || defined(GCgn)
/* NO: -concurrent croaks on SMevac.lc with this
#define REG_OldGen	esi
*/
#endif	/* GCap || GCgn */

#else	/* default: MAIN_REG_MAP */

/* callee saves */
#define CALLEE_SAVES_Base
#define CALLEE_SAVES_SpB

/* caller saves -- none */

/* After trying to steal 4 regs, ... crash:

   works again if:
   - give back esi
   - give back edi
   - give back edi & ebp

   does not work if
   - give back ebp
*/

/* SpB and R1 are the two heaviest hitters, followed by SpA.
   Hp comes next, followed closely by R2;
   then RetReg, then R3 and R4.
   At least based on some static counts.
   SIGH.  WDP 95/09
*/
#define REG_Base    ebx
#define REG_SpB	    ebp
#if STOLEN_X86_REGS >= 3
# define REG_R1	    esi
# define CALLEE_SAVES_R1
#endif
#if STOLEN_X86_REGS >= 4
# define REG_SpA    edi
# define CALLEE_SAVES_SpA
#endif
#if STOLEN_X86_REGS >= 5
/*
# define REG_Hp    ecx
# define CALLER_SAVES_Hp
# define CALLER_SAVES_SYSTEM
*/
/* because we *might* have Hp in a caller-saves register */
#endif


#endif	/* SCAV_REG_MAP */
#endif	/* SCAN_REG_MAP */
#endif	/* MARK_REG_MAP */

#endif /* iX86 */





































#if m68k_TARGET_ARCH

#define REG(x) __asm__(#x)

#if defined(FLUSH_REG_MAP)
#define REG_FlushP  	a2
#define REG_FStack  	a3
#define REG_FlushTemp   a4
#else
#if defined(MARK_REG_MAP)
#define REG_Mark  	a2
#define REG_MStack  	a3
#define REG_MRoot	a4
#define REG_BitArray    a5
#define REG_HeapBase	d3
#define REG_HeapLim 	d4
#else
#if defined(SCAN_REG_MAP)
#define REG_Scan  	a2
#define REG_New  	a3
#define REG_LinkLim	a4
#else
#if defined(SCAV_REG_MAP)
#define REG_Scav  	a2
#define REG_ToHp  	a3
#if defined(GCap)
#define REG_OldGen	a4
#else
#if defined(GCgn)
#define REG_OldGen	a4
#define REG_AllocGen	a5
#define REG_OldHp	d3
#endif	/* GCap */
#endif	/* GCgn */
#else	/* default: MAIN_REG_MAP */

/* callee saves */
#define CALLEE_SAVES_FltReg1
#define CALLEE_SAVES_DblReg1
#if !defined(CONCURRENT)
# define CALLEE_SAVES_FltReg2
# define CALLEE_SAVES_FltReg3
# define CALLEE_SAVES_FltReg4
# define CALLEE_SAVES_DblReg2
#endif
#if HAVE_LONG_LONG && SIZEOF_LONG < 8
#define CALLEE_SAVES_LngReg1
#define CALLEE_SAVES_LngReg2
#endif
#define CALLEE_SAVES_Base
#define CALLEE_SAVES_SpB
#define CALLEE_SAVES_SpA
#define CALLEE_SAVES_Hp
#define CALLEE_SAVES_SuA
#define CALLEE_SAVES_SuB

#define CALLEE_SAVES_R1
#define CALLEE_SAVES_R2
#define CALLEE_SAVES_Ret

/* caller saves -- none */

#define REG_Base	a2

#define REG_SpB		a3
#define REG_SpA		a4

#define REG_Hp	    	d3
#define REG_SuA     	d4
#define REG_SuB     	d5

#define REG_R1    	a5
#define REG_R2    	d6

#define REG_Ret		d7

#define REG_Flt1	fp2
#if !defined(CONCURRENT)
/* The extra float registers are not worth the tradeoff in
   context-switch time for most programs (for now, at least).
*/
#define REG_Flt2	fp3
#define REG_Flt3	fp4
#define REG_Flt4	fp5
#endif

#define REG_Dbl1	fp6
/* The extra double registers are not worth the tradeoff in
   context-switch time for most programs (for now, at least).
*/
#if !defined(CONCURRENT)
#define REG_Dbl2	fp7
#endif

#endif	/* SCAV_REG_MAP */
#endif	/* SCAN_REG_MAP */
#endif	/* MARK_REG_MAP */
#endif	/* FLUSH_REG_MAP */

#endif /* m68k */



















#if mipsel_TARGET_ARCH || mipseb_TARGET_ARCH

#define REG(x) __asm__("$" #x)

#if defined(MARK_REG_MAP)
#define REG_Mark  	16
#define REG_MStack  	17
#define REG_MRoot	18
#define REG_BitArray    19
#define REG_HeapBase	20
#define REG_HeapLim 	21
#else
#if defined(SCAN_REG_MAP)
#define REG_Scan  	16
#define REG_New  	17
#define REG_LinkLim	18
#else
#if defined(SCAV_REG_MAP)
#define REG_Scav  	16
#define REG_ToHp  	17
#if defined(GCap) || defined(GCgn)
#define REG_OldGen	18
#endif	/* GCap || GCgn */
#else	/* default: MAIN_REG_MAP */

/* callee saves */
#define CALLEE_SAVES_FltReg1
#define CALLEE_SAVES_FltReg2
#define CALLEE_SAVES_FltReg3
#define CALLEE_SAVES_FltReg4
#define CALLEE_SAVES_DblReg1
#define CALLEE_SAVES_DblReg2
#if HAVE_LONG_LONG && SIZEOF_LONG < 8
#define CALLEE_SAVES_LngReg1
#define CALLEE_SAVES_LngReg2
#endif
#define CALLEE_SAVES_SpA
#define CALLEE_SAVES_SuA
#define CALLEE_SAVES_SpB
#define CALLEE_SAVES_SuB
#define CALLEE_SAVES_Hp
#define CALLEE_SAVES_HpLim

#define CALLEE_SAVES_Ret

/* caller saves */
#define CALLER_SAVES_R1
#define CALLER_SAVES_R2
#define CALLER_SAVES_R3
#define CALLER_SAVES_R4
#define CALLER_SAVES_R5
#define CALLER_SAVES_R6
#define CALLER_SAVES_R7
#define CALLER_SAVES_R8

#define CALLER_SAVES_USER

#define REG_R1		9
#define REG_R2    	10
#define REG_R3    	11
#define REG_R4    	12
#define REG_R5    	13
#define REG_R6    	14
#define REG_R7    	15
#define REG_R8    	24

#define REG_Flt1	f20
#define REG_Flt2	f22
#define REG_Flt3	f24
#define REG_Flt4	f26

#define REG_Dbl1	f28
#define REG_Dbl2	f30

#define REG_SpA    	16
#define REG_SuA    	17
#define REG_SpB    	18
#define REG_SuB    	19

#define REG_Hp	    	20
#define REG_HpLim	21

#define REG_Ret	    	22

#define REG_StkStub 	23

#endif	/* SCAV_REG_MAP */
#endif	/* SCAN_REG_MAP */
#endif	/* MARK_REG_MAP */

#endif /* mipse[lb] */



























#if powerpc_TARGET_ARCH || rs6000_TARGET_ARCH

#define REG(x) __asm__(#x)

#if defined(MARK_REG_MAP)
#define REG_Mark  	r22
#define REG_MStack  	r23
#define REG_MRoot	r24
#define REG_BitArray    r25
#define REG_HeapBase	r26
#define REG_HeapLim 	r27
#else
#if defined(SCAN_REG_MAP)
#define REG_Scan  	r22
#define REG_New  	r23
#define REG_LinkLim	r24
#else
#if defined(SCAV_REG_MAP)
#define REG_Scav  	r22
#define REG_ToHp  	r23
#if defined(GCap) || defined(GCgn)
#define REG_OldGen	r24
#endif	/* GCap || GCgn */
#else	/* default: MAIN_REG_MAP */

/* callee saves */
#define CALLEE_SAVES_FltReg1
#define CALLEE_SAVES_FltReg2
#define CALLEE_SAVES_FltReg3
#define CALLEE_SAVES_FltReg4
#define CALLEE_SAVES_DblReg1
#define CALLEE_SAVES_DblReg2
#if HAVE_LONG_LONG && SIZEOF_LONG < 8
#define CALLEE_SAVES_LngReg1
#define CALLEE_SAVES_LngReg2
#endif
#define CALLEE_SAVES_SpA
#define CALLEE_SAVES_SuA
#define CALLEE_SAVES_SpB
#define CALLEE_SAVES_SuB
#define CALLEE_SAVES_Hp
#define CALLEE_SAVES_HpLim

#define CALLEE_SAVES_Ret

#define CALLEE_SAVES_R1
#define CALLEE_SAVES_R2
#define CALLEE_SAVES_R3
#define CALLEE_SAVES_R4
#define CALLEE_SAVES_R5
#define CALLEE_SAVES_R6
#define CALLEE_SAVES_R7
#define CALLEE_SAVES_R8

#define REG_R1		r14
#define REG_R2    	r15
#define REG_R3    	r16
#define REG_R4    	r17
#define REG_R5    	r18
#define REG_R6    	r19
#define REG_R7    	r20
#define REG_R8    	r21

#define REG_Flt1	fr14
#define REG_Flt2	fr15
#define REG_Flt3	fr16
#define REG_Flt4	fr17

#define REG_Dbl1	fr18
#define REG_Dbl2	fr19

#define REG_SpA    	r22
#define REG_SuA    	r23
#define REG_SpB    	r24
#define REG_SuB    	r25

#define REG_Hp	    	r26
#define REG_HpLim	r27

#define REG_Ret	    	r28

#define REG_StkStub 	r29

#endif	/* SCAV_REG_MAP */
#endif	/* SCAN_REG_MAP */
#endif	/* MARK_REG_MAP */

#endif /* powerpc */

































#if sparc_TARGET_ARCH

#define REG(x) __asm__("%" #x)

#if defined(MARK_REG_MAP)
#define REG_Mark  	i0
#define REG_MStack  	i1
#define REG_MRoot	i2
#define REG_BitArray    i3
#define REG_HeapBase	i4
#define REG_HeapLim 	i5
#else
#if defined(SCAN_REG_MAP)
#define REG_ScanBase  	g4
/* NB: *not* defining this (so that everything is done w/ global variables)
   does *not* work; I suspect that the Sca[nv]RegTable is not being
   initialised somewhere... WDP 95/10
*/
#else
#if defined(SCAV_REG_MAP)
#define REG_ScavBase  	g4
/* see comment above */
#else	/* default: MAIN_REG_MAP */

/* callee saves (nothing) */

/* caller saves (fp registers) */

#define CALLER_SAVES_USER

#define CALLER_SAVES_FltReg1
#define CALLER_SAVES_FltReg2
#define CALLER_SAVES_FltReg3
#define CALLER_SAVES_FltReg4
#define CALLER_SAVES_DblReg1
#define CALLER_SAVES_DblReg2
#if HAVE_LONG_LONG && SIZEOF_LONG < 8
#define CALLER_SAVES_LngReg1
#define CALLER_SAVES_LngReg2
#endif

#define REG_R1	    	l1
#define REG_R2    	l2
#define REG_R3    	l3
#define REG_R4    	l4
#define REG_R5    	l5
#define REG_R6    	l6
#define REG_R7    	l7

#define REG_Flt1	f2
#define REG_Flt2	f3
#define REG_Flt3	f4
#define REG_Flt4	f5
#define REG_Dbl1	f6
#define REG_Dbl2	f8

#define REG_SpA    	i0
#define REG_SuA    	i1
#define REG_SpB    	i2
#define REG_SuB    	i3

#define REG_Hp	    	i4
#define REG_HpLim	i5

#define REG_Ret	    	l0

#define REG_StkStub  	i7

#define NCG_Reserved_I1	g1
#define NCG_Reserved_I2	g2
#define NCG_Reserved_F1	f14
#define NCG_Reserved_F2 f15
#define NCG_Reserved_D1	f16
#define NCG_Reserved_D2	f18

#endif	/* SCAV_REG_MAP */
#endif	/* SCAN_REG_MAP */
#endif	/* MARK_REG_MAP */

#endif /* sparc */





#endif	/* __STG_GCC_REGS__ || COMPILING_NCG */

#endif /* MACHREGS_H */


