



















#ifndef SMinterface_H
#define SMinterface_H




















typedef struct {
    P_ hp;	/* last successfully allocated word */
    P_ hplim;   /* last allocatable word */

    I_ rootno; /* No of heap roots stored in roots */
    P_ *roots;  /* Array of heap roots -- must be allocated (not static) */
    P_ CAFlist; /* List of updated CAF's */

#if defined(GCap) || defined(GCgn)
    P_ OldMutables; /* List of old generation mutable closures */
    P_ OldLim;      /* Ptr to end of the old generation */
#endif

#ifndef PAR
    P_ ForeignObjList;     /* List of all Foreign objects (in new generation) */

#if defined(GCap) || defined(GCgn)
    P_ OldForeignObjList;  /* List of all Foreign objects in old generation */
#endif

    P_ StablePointerTable;
	/* Heap allocated table used to store stable pointers in */
#endif /* !PAR */

    I_ hardHpOverflowSize;  /* Some slop at the top of the heap which
			       (hopefully) provides enough space to let
			       us recover from heap overflow exceptions */
} smInfo;

extern smInfo StorageMgrInfo;







#ifndef CONCURRENT
# define SM_MAXROOTS 9		/* 8 Vanilla Regs + stable pointer table*/
#else
# ifndef PAR
#   ifdef GRAN
#    define SM_MAXROOTS (10 + (MAX_PROC*2) + 2 )
		     /* unthreaded + hd/tl thread queues + Current/Main TSOs */
#   else
#     define SM_MAXROOTS 6      /* See c-as-asm/HpOverflow.lc */
#   endif
# else
#  define SM_MAXROOTS 6         /* See c-as-asm/HpOverflow.lc */
# endif
#endif




IF_RTS(void    initSM	    (STG_NO_ARGS);)
IF_RTS(rtsBool exitSM	    PROTO((smInfo *sm));)
IF_RTS(rtsBool initStacks   PROTO((smInfo *sm));)
IF_RTS(rtsBool initHeap	    PROTO((smInfo *sm));)
#ifdef CONCURRENT
IF_RTS(rtsBool initThreadPools (STG_NO_ARGS);)
#endif
#ifdef PAR
IF_RTS(void init_gr_profiling PROTO((int, char **, int, char **));)
#endif

I_ collectHeap PROTO((W_ reqsize, smInfo *sm, rtsBool do_full_collection));

IF_RTS(void unmapMiddleStackPage PROTO((char *, int));) /* char * == caddr_t ? */

#if defined(PROFILING) || defined(PAR)
IF_RTS(void handle_tick_serial(STG_NO_ARGS);)
IF_RTS(void handle_tick_noserial(STG_NO_ARGS);)
#endif

/* EXTFUN(_startMarkWorld); */

StgDouble usertime(STG_NO_ARGS);
StgDouble elapsedtime(STG_NO_ARGS);
void	  start_time(STG_NO_ARGS);
void	  end_init(STG_NO_ARGS);

#ifdef PAR
void EvacuateLocalGAs PROTO((rtsBool full));
void RebuildGAtables  PROTO((rtsBool full));
#endif













































































#define GC_HARD_LIMIT_EXCEEDED 0
#define GC_SOFT_LIMIT_EXCEEDED 1
#define GC_SUCCESS 2

































































































































































































































#if 1 /* ndef CONCURRENT * /? HWL */

typedef struct {
    PP_	botA;	/* Points to bottom-most word of A stack */
    P_		botB;	/* Points to bottom-most word of B stack */
} stackData;

extern stackData stackInfo;

#endif /* !CONCURRENT */













#if defined(GCdu) || defined (GCap) || defined (GCgn)
#define _INFO_COPYING
#define _INFO_COMPACTING
#define _INFO_MARKING
#else
#if   defined(GC2s)
#define _INFO_COPYING

#else
#if defined(GC1s)
#define _INFO_COMPACTING
#define _INFO_MARKING
#else
/* NO_INFO_SPECIFIED (ToDo: an #error ?) */
#endif
#endif
#endif



























































#endif /* SMinterface_H */

