






#ifndef SMUPDATE_H
#define SMUPDATE_H































































































I_ SqueezeUpdateFrames PROTO((P_, P_, P_));

EXTDATA_RO(vtbl_StdUpdFrame);
EXTFUN(StdUpdFrameDirectReturn);

EXTFUN(StdErrorCode); /* Where should this go? */
EXTFUN(UpdErr);
EXTFUN(IndUpdRetV0);
EXTFUN(IndUpdRetV1);
EXTFUN(IndUpdRetV2);
EXTFUN(IndUpdRetV3);
EXTFUN(IndUpdRetV4);
EXTFUN(IndUpdRetV5);
EXTFUN(IndUpdRetV6);
EXTFUN(IndUpdRetV7);
EXTFUN(IndUpdRetDir);

/* 
   Note that UNVEC() is used to select whole statements (declarations) as
   well as labels.  Please don't put parentheses around the expansion.
 */

#ifdef __STG_REV_TBLS__
#define RVREL(offset) (-(offset)-1)
#define DIRECT(target) (target)
#define UNVEC(direct,vector) direct
#else
#define RVREL(offset) (offset)
#define DIRECT(target) (*(target))
#define UNVEC(direct,vector) vector
#endif

#ifdef CONCURRENT
/* for stack chunking */
extern const W_ vtbl_Underflow[];
EXTFUN(UnderflowDirectReturn);
EXTFUN(UnderflowVect0);
EXTFUN(UnderflowVect1);
EXTFUN(UnderflowVect2);
EXTFUN(UnderflowVect3);
EXTFUN(UnderflowVect4);
EXTFUN(UnderflowVect5);
EXTFUN(UnderflowVect6);
EXTFUN(UnderflowVect7);
EXTFUN(StackUnderflowEnterNode);
EXTFUN(CommonUnderflow);
EXTFUN(PrimUnderflow);
#endif	/* CONCURRENT */

/* Now, we always use pointers in update frame, even in the threaded world */

#define PUSH_RET(frame, rv)	    	(frame)[BREL(UF_RET)] = (W_)(rv)
#define PUSH_UPDATEE(frame, updatee)	(frame)[BREL(UF_UPDATEE)] = (W_)(updatee)
#define PUSH_SuB(frame, sub)		(frame)[BREL(UF_SUB)] = (W_)(sub)
#define PUSH_SuA(frame, sua)	    	(frame)[BREL(UF_SUA)] = (W_)(sua)

#if defined(PROFILING)
#define	PUSH_STD_CCC(frame) (frame)[BREL(UF_COST_CENTRE)] = (W_)(CCC)
#else
#define	PUSH_STD_CCC(frame)
#endif

/* When GRABing, "frame" pts to an update frame */

#define GRAB_RET(frame)	    	((void *)((frame)[BREL(UF_RET)]))
#define GRAB_SuB(frame)     	((P_)((frame)[BREL(UF_SUB)]))
#define GRAB_SuA(frame)     	((PP_)((frame)[BREL(UF_SUA)]))
#define GRAB_UPDATEE(frame) 	((P_)((frame)[BREL(UF_UPDATEE)]))
#define GRAB_COST_CENTRE(frame)	((CostCentre)((frame)[BREL(UF_COST_CENTRE)]))

#define PUSH_STD_UPD_FRAME(target, SpA_offset, SpB_offset)	\
    do {							\
    	P_ __frame;					  	\
	UPDF_STD_PUSHED();	/* ticky-ticky, spat */		\
	__frame = SpB - BREL(SpB_offset + STD_UF_SIZE);		\
    	PUSH_RET(__frame, RetReg);  	    	    	    	\
	PUSH_SuB(__frame, SuB); 		    	    	\
	PUSH_SuA(__frame, SuA); 		    	    	\
	PUSH_UPDATEE(__frame, target);	    	    	    	\
	PUSH_STD_CCC(__frame);				    	\
	SuB = __frame;					    	\
	SuA = SpA - AREL(SpA_offset);				\
    } while(0)

#define POP_STD_UPD_FRAME() 	    	    	    	    	\
    do {    	    	    	    	    	    	    	\
    	RetReg = GRAB_RET(SpB);	    	    	    	    	\
        SuB = GRAB_SuB(SpB);    	    	    	    	\
        SuA = GRAB_SuA(SpB);    	    	    	    	\
        SpB += BREL(STD_UF_SIZE);   	    	    	    	\
    } while(0);
















EXTDATA_RO(BH_UPD_info);
EXTFUN(BH_UPD_entry);
EXTDATA_RO(BH_SINGLE_info);
EXTFUN(BH_SINGLE_entry);

#define UPD_BH(heapptr,infolbl)		INFO_PTR(heapptr) = (W_) infolbl




















#if defined(CONCURRENT)
#define UPD_BH_UPDATABLE(heapptr)	UPD_BH(heapptr,BH_UPD_info)
#else
#define UPD_BH_UPDATABLE(heapptr)	/* nothing -- BHed by GC */
#endif

#define UPD_BH_SINGLE_ENTRY(heapptr) 	UPD_BH(heapptr,BH_SINGLE_info)
					/* BHed on entry -- GC cant do it */


























EXTDATA_RO(Caf_info);
EXTFUN(Caf_entry);

#define UPD_CAF(cafptr, bhptr)					\
  do {								\
  SET_INFO_PTR(cafptr, Caf_info);				\
  IND_CLOSURE_PTR(cafptr)  = (W_) (bhptr);			\
  IND_CLOSURE_LINK(cafptr) = (W_) StorageMgrInfo.CAFlist;	\
  StorageMgrInfo.CAFlist   = (P_) (cafptr);			\
  } while(0)















































EXTDATA_RO(PAP_info);
EXTFUN(PAP_entry);
EXTFUN(UpdatePAP);









#ifdef CONCURRENT

/* In the concurrent world, the targed of an update might
   be a black hole with a blocking queue attached.  If so,
   it will already be on the mutables list, and we have to be careful
   not to put it on twice else it screws up the list. */
#define ALREADY_LINKED(closure)	\
    (IS_MUTABLE(INFO_PTR(closure)) && MUT_LINK(closure) != MUT_NOT_LINKED)

# if defined(GRAN)
P_ AwakenBlockingQueue PROTO((P_));
# else
void AwakenBlockingQueue PROTO((P_));
# endif

# ifdef MAIN_REG_MAP
#  define AWAKEN_BQ(updatee)						\
do { if (IS_BQ_CLOSURE(updatee))					\
 STGCALL1(void,(void *, P_), AwakenBlockingQueue, (P_) BQ_ENTRIES(updatee)); \
} while(0);
# endif

# ifdef NULL_REG_MAP
#  define AWAKEN_BQ(updatee)			\
do { if (IS_BQ_CLOSURE(updatee))		\
 AwakenBlockingQueue((P_)BQ_ENTRIES(updatee));	\
} while(0);
# endif

# define AWAKEN_INPLACE_BQ()

#else /* !CONCURRENT */

# define ALREADY_LINKED(closure) 0 /* NB: see note above in CONCURRENT */

# define AWAKEN_BQ(updatee)
# define AWAKEN_INPLACE_BQ()

#endif /* CONCURRENT */

EXTDATA_RO(Ind_info);
EXTFUN(Ind_entry);
#ifndef TICKY_TICKY
# define Ind_info_TO_USE Ind_info
#else
EXTDATA_RO(Perm_Ind_info);
EXTFUN(Perm_Ind_entry);

# define Ind_info_TO_USE ((AllFlags.doUpdEntryCounts) ? Perm_Ind_info : Ind_info)
#endif

#if defined(GC2s) || defined(GC1s) || defined(GCdu)

#define INPLACE_UPD_HDR(closure,infolbl,cc,size,ptrs) 		\
	UPD_FIXED_HDR(closure,infolbl,cc)

#define UPD_IND(updclosure, heapptr)   				\
	UPDATED_SET_UPDATED(updclosure); /* ticky */		\
    	AWAKEN_BQ(updclosure);					\
	SET_INFO_PTR(updclosure, Ind_info_TO_USE);		\
	IND_CLOSURE_PTR(updclosure) = (W_)(heapptr)

#define UPD_INPLACE_NOPTRS(livemask)				\
	UPDATED_SET_UPDATED(Node); /* ticky */			\
	AWAKEN_BQ(Node);

#define UPD_INPLACE_PTRS(livemask)				\
	UPDATED_SET_UPDATED(Node); /* ticky */			\
	AWAKEN_BQ(Node);













#else /* !(2s/1s/du) */
# if defined(GCap) || defined(GCgn)

/* same as before */
#define INPLACE_UPD_HDR(closure,infolbl,cc,size,ptrs) 			\
  UPD_FIXED_HDR(closure,infolbl,cc)

/* updclosure is the updatee, heapptr is what to update it with */
#define UPD_IND(updclosure, heapptr)					\
{ UPDATED_SET_UPDATED(updclosure); /* ticky */				\
  if ( ((P_)(updclosure)) > StorageMgrInfo.OldLim ) {			\
      UPD_NEW_IND(); /*ticky*/						\
  } else { 								\
      UPD_OLD_IND(); /*ticky*/                                 		\
      if(!ALREADY_LINKED(updclosure)) {					\
          MUT_LINK(updclosure) = (W_) StorageMgrInfo.OldMutables;	\
          StorageMgrInfo.OldMutables = (P_) (updclosure);		\
      }	    	    	    	    	    	    	    		\
  }									\
  AWAKEN_BQ(updclosure);						\
  SET_INFO_PTR(updclosure, Ind_info_TO_USE);				\
  IND_CLOSURE_PTR(updclosure) = (W_)(heapptr);	    	    		\
}

/* 
 * In threaded-land, we have to do the same nonsense as UPD_INPLACE_PTRS if
 * we were a blocking queue on the old mutables list.
 */
#define UPD_INPLACE_NOPTRS(live_regs_mask)	  			\
  UPDATED_SET_UPDATED(Node); /* ticky */				\
  if ( Node > StorageMgrInfo.OldLim) { 					\
      UPD_NEW_IN_PLACE_NOPTRS(); /*ticky*/                		\
      AWAKEN_BQ(Node);							\
  } else {								\
      UPD_OLD_IN_PLACE_NOPTRS(); /*ticky*/				\
      if(ALREADY_LINKED(Node)) {					\
          /* We are already on the old mutables list, so we		\
	     can't update in place any more */				\
          HEAP_CHK(live_regs_mask, _FHS+MIN_UPD_SIZE, 0);		\
	    /* ticky-ticky (NB: was ALLOC_UPD_CON) */			\
          ALLOC_CON(_FHS,1,MIN_UPD_SIZE-1,_FHS+MIN_UPD_SIZE);		\
          CC_ALLOC(CCC,_FHS+MIN_UPD_SIZE,CON_K);			\
	  /* must awaken after any possible GC */			\
	  AWAKEN_BQ(Node);						\
          SET_INFO_PTR(Node, Ind_info_TO_USE);				\
          IND_CLOSURE_PTR(Node) = (W_)(Hp-(_FHS+MIN_UPD_SIZE-1));	\
          Node = Hp-(_FHS+MIN_UPD_SIZE-1); 				\
      }									\
  }

#define UPD_INPLACE_PTRS(live_regs_mask)				\
  UPDATED_SET_UPDATED(Node); /* ticky */				\
  if ( Node > StorageMgrInfo.OldLim) {					\
      UPD_NEW_IN_PLACE_PTRS(); /*ticky*/                       		\
      AWAKEN_BQ(Node);							\
  } else {								\
      /* redirect update with indirection */				\
      UPD_OLD_IN_PLACE_PTRS(); /*ticky*/				\
      /* Allocate */							\
      HEAP_CHK(live_regs_mask, _FHS+MIN_UPD_SIZE, 0); 			\
	/* ticky-ticky (NB: was ALLOC_UPD_CON) */			\
      ALLOC_CON(_FHS,1,MIN_UPD_SIZE-1,_FHS+MIN_UPD_SIZE);		\
      CC_ALLOC(CCC,_FHS+MIN_UPD_SIZE,CON_K);				\
									\
      if (!ALREADY_LINKED(Node)) {					\
          MUT_LINK(Node) = (W_) StorageMgrInfo.OldMutables; 		\
          StorageMgrInfo.OldMutables = (P_) (Node);			\
      }	    	    	    	    	    	    			\
      /* must awaken after any possible GC */				\
      AWAKEN_BQ(Node);							\
      SET_INFO_PTR(Node, Ind_info_TO_USE);				\
      IND_CLOSURE_PTR(Node) = (W_)(Hp-(_FHS+MIN_UPD_SIZE-1)); 		\
      Node = Hp-(_FHS+MIN_UPD_SIZE-1);					\
  }
# endif /* GCap || GCgn */
#endif

















#ifdef GC_MUT_REQUIRED
#define FREEZE_MUT_HDR(freezeclosure,immutinfo) \
	SET_INFO_PTR(freezeclosure, immutinfo)
#else
#define FREEZE_MUT_HDR(freezeclosure,immutinfo) \
	SET_INFO_PTR(freezeclosure, immutinfo)
#endif

#endif /* SMUPDATE_H */

